features = {'ONE' : 'num', 'SOME' : 'num',
            '1': 'p', '2': 'p', '3': 'p',
            'neg':'pol', 'aff':'pol',
            'acc':'k', 'nom':'k',
            'fin' : 'fin', 'nonf' : 'fin',
            'NOT+WH': 'wh', 'WH':'wh'
}

default = {'num' : 'ONE', 'p': '3', 'pol':'aff','k':'acc', 'fin':'fin'}


lexicon = {

    # ATTRIBUTIVE RELATION
    'F:ATT'  :  ['', '=a:X', '=n:X', '+num:$num$', '+pred', 'n:X+1', '-num:$num$'],

    'F:SPEC' : ['', '=a', '+pred:pred', 
                    '=d:X', '+det:$det$', '+p:$p$', '+num:$num$', '+k:$k$', 
                    'd:X+1','-det:$det$', '-p:$p$', '-num:$num$', '-k:$k$'],

#    'F:REL'  : ['', '=p', '=d:X', 'd:X+1'],


    # QUANTIFIER RELATION
    'F:Q' : ['', '=q', '+num:$num$', '=n:20', '+num:$num$','+q', 'n:21', '-num:$num$'],

    # DET. RELATION
    'F:DET' : ['', '=det', '+num:$num$',
               '=n:22', '+num:$num$', '+det:$det$',
               'd:1', '-det:$det$', '-p:3', '-num:$num$', '-k:$k$'],

    'F:POSS' : ['S', '=d:3', '+det', '+p', '+num:$num$', '+k:acc',
                '=n:22', '+num:$num$', '>',
                'd:4', '-det:THIS', '-p:3', '-num:$num$', '-k:$k$'],
               
                 

    # fused Spec+H
    'f:SOME+UNSP' : ['', '=n:22',  '+num:SOME', 'd:3', '-det:SOME', '-p:3', '-num:SOME', '-k:$k$'],

     

    
    # SELECTION RELATION
    'F:SEL_1' : ['',    
               '=q','+num:$num$', '+q',          
               '=gen',
               'd:3', '-det:SEL', '-p:$p$', '-num:$num$', '-k:$k$'],
    'F:SEL_2' : ['',    
               '=det','+num:$num$', '+det:UNSP',          
               '=gen',
               'd:3', '-det:SEL', '-p:$p$', '-num:$num$', '-k:$k$'],
    
    # CLASSIFIER AND PARTONOMY RELATION (kind of, part of)
    'F:CLASS' : ['',                
                '=d:3', '+det:$det$', '+p:$p$', '+num:$num$', '+k:$k$',
                '=gen',
                'd:4','-det:$det$', '-p:$p$', '-num:$num$', '-k:$k$'
                ],
             

    # PARTONOMY RELATION
 #   'F:PART' : ['',
 #               '=d:3','+det:$det$', '+p:$p$', '+num:$num$', '+k:$k$',
 #               '=gen',
 #               'd:4','-det:$det$', '-p:$p$', '-num:$num$', '-k:$k$',
 #               ],


    # OBJECTVE RELATION
    'F:OBJ_1' : ['',
               '=d','+det', '+p', '+num',  '+k:acc', '>',
               '=v:1', '+meta:$meta$',              
               'v:2', '-meta:$meta$'],
    'F:OBJ_2' : ['',
               '=c:5', '+ctype:fact', '>',
               '=v:1', '+meta:meta',              
               'v:2', '-meta:meta'],

    
    # COMPLEMENTS AND CIRCUMSTANTES
    'F:MD': ['','=p:X', '+r', '=v:X', '+meta:$meta$', 'v:X+1', '-meta:$meta$'],

    # PREDICATIVE RELATION

    'f:BE-P' : ['', '=a','+pred:pred', 'v:13', '-cop:cop'],
    'f:BE-L' : ['', '=p', '+r', 'v:13', '-cop:cop'],
    'f:BE-C' : ['', '=d:3', '+det:$det$', '+p:$p$', '+num:$num$', '+k:nom', 'v:13', '-cop:cop'],


    'f:PRED_1' : [ '',  '=v', '+meta', 'v:24', '-be:NOT+BE','-pol'],
    'f:PRED_2' : [ '',  '=v', '+cop', 'v:24', '-be:BE','-pol'],



    'F:SUBJ' : [ '', '=d', '=v', 'i:1'],



    # OBLIQUE CASE MARKERS
    'f:DAT' : ['to', '=d:3', '+det', '+p', '+num', '+k:acc', '>', 'p:4', '-r:DAT'],
    # MANNER
    'f:ARG' : ['about','=d:3', '+det', '+p', '+num', '+k:acc', '>','p:6', '-r:ARG'],
    'f:INSTR' : ['with','=d:3', '+det', '+p', '+num', '+k:acc', '>','p:7', '-r:INSTR'],
#    'f:LOC1' : ['in','=d:3', '+det', '+p', '+num', '+k:acc', '>','p:8', '-r:LOC'],
    'f:DIR' : ['towards','=d:3', '+det', '+p', '+num', '+k:acc', '>','p:9', '-r:DIR'],
    'f:SRC' : ['from', '=d:3', '+det', '+p', '+num', '+k:acc', '>', 'p:10', '-r:SRC'],
#    'f:CAUSE1_1' : ['because','=pgen', '>','p:11'],
#    'f:CAUSE1_2' : ['because','=c:3', '+wh:NOT+WH', '>','p:11'],

    'f:BEN' : ['for', '=d:3','+det',  '+p', '+num', '+k:acc', '>','p:12', '-r:BEN'],
    'f:COMIT' : ['with','=d:3', '+det', '+p',  '+num', '+k:acc', '>','p:13', '-r:COM'],
    'f:LOC_1': ['in','=d:3','+det',  '+p',  '+num', '+k:acc', '>','p:14', '-r:LOC'],
    'f:LOC_2': ['','=p_adv','p:14', '-r:LOC'],
    'f:DUR' : ['for', '=time:3', '>','p:15', '-r:DUR'],
    'f:TIME_1': ['at', '=d:3', '+det', '+p',  '+num', '+k:acc', '>', 'p:16', '-r:TIME'],
    'f:TIME_2' : ['', '=t_adv', 'p:16', '-r:TIME'],
    'f:LIKE_1' : ['like', '=d:3', '+det', '+p', '+num', '+k:acc', '>', 'a:1', '-pred:pred'],
    'f:LIKE_2' : ['like', '=d:3', '+det', '+p', '+num', '+k:acc', '>', 'p:18', '-r:LIKE'],
    'f:SAME_AS' : ['as', '=d:3','+det',  '+p', '+num', '+k:acc', '>', 'p:17', '-r:AS'],
    'f:CAUSE' : ['because','=gen', '>','p:19', '-r:CAUS'],


    
    'f:TOP' : [',', '=p:X', '+r', 'p:X', '-top'],
    
    # EVIDENTIAL

    # GENITIVE
    'f:GEN' : ['of', '=d:3', '+det', '+p', '+num', '+k:acc', '>', 'gen'],





    ##################
    #                #
    #  LEXICAL HEADS #
    #                #
    ##################

    # EVALUATORS, DESCRIPTORS
    'P:GOOD'  :    ['good', 'a:16', '-pred:pred'],
    'P:BAD'   :    ['bad', 'a:16', '-pred:pred'],
    'P:BIG'   :    ['big', 'a:14', '-pred:pred'],
    'P:SMALL' :    ['small', 'a:14', '-pred:pred'],
    
    # SUBSTANTIVES
    'PEOPLE' :  ['people', 'n:1', '-num:SOME'],
    'THING'  :  ['thing-$num$', 'n:1', '-num:$num$'],
    'PERSON' :  ['person-$num$', 'n:1', '-num:$num$'],
    'BODY'   :  ['body-$num$', 'n:1', '-num:$num$'],
    'PLACE'  :  ['place-$num$', 'n:1', '-num:$num$'],
    'TIME'   :  ['time', 'n:1', '-num:ONE'],
    'TIMES'  :  ['times', 'n:1', '-num:SOME'],

    'ME'   :    ['me-$k$', 'd:2', '-det:ME', '-p:1', '-num:ONE', '-k:$k$'], 
    'YOU'   :   ['you', 'd:2', '-det:ME', '-p:2', '-num:SOME', '-k:$k$'],

    'IT' : ['it', 'd:2','-det:THIS',  '-p:3', '-num:$num$', '-k:$k$'],
    'SOMEONE' : ['someone', 'd:2', '-det:UNSP', '-p:3', '-num:ONE', '-k:$k$'],
    'SOMETHING' : ['something', 'd:2', '-det:THIS', '-p:3', '-num:ONE', '-k:$k$'],

    'HIM' : ['he-$k$', 'd:2', '-det:THIS', '-p:3', '-num:ONE', '-k:$k$'],
    'HER' : ['she-$k$', 'd:2', '-det:THIS', '-p:3', '-num:ONE', '-k:$k$'],

    'THIS_THING' : ['this-$num$', 'd:2', '-det:THIS', '-p:3', '-num:ONE', '-k:$k$'], 	
    'CATAPHORA'  : ['this:', 'd:2', '-det:THIS', '-p:3', '-det:THIS', '-num:$num$', '-k:$k$'],
    'THAT_THING' : ['that-$num$', 'd:2', '-det:THIS', '-p:3', '-num:ONE', '-k:$k$'], 	


    # KIND, PART
    'KIND' :  ['kind-$num$', 'n:1', '-num:$num$'],
    'PART' :  ['part-$num$', 'n:1', '-num:$num$'],
    'f:PART-OF' :  ['part-$num$', '=gen', '>', 'n:1', '-num:$num$'],
    'f:KIND-OF' :  ['kind-$num$', '=gen', '>', 'n:1', '-num:$num$'],


    #QUANTIFIERS AND DETERMINERS
    'ONE' :    ['one', 'det','-num:ONE', '-det:UNSP'],
  
    'TWO' :    ['two', 'q', '-num:SOME', '-q'],
    'FEW' :    ['few', 'q', '-num:SOME', '-q'],

    'SOME' : ['some', 'det',  '-num:SOME', '-det:UNSP'],
    'MANY' :   ['many', 'det', '-num:SOME', '-det:UNSP'],

    
    'THIS' : ['this-$num$', 'det','-num:$num$', '-det:THIS'],
    'THE_SAME' : ['the_same', 'det', '-num:$num$', '-det:THE_SAME'],
    'THE_OTHER' : ['the_other', 'det','-num:$num$', '-det:THE_OTHER'],

    'ONE+UNSP' : ['a', 'det', '-num:ONE', '-det:UNSP'],

    'f:ALL' : ['all', 
               '=d:3', '+det:$det$','+p:$p$', '+num:$num$', '+k:$k$','>',
               'd:4', '-det:$det$', '-p:$p$', '-num:$num$', '-k:$k$'],

    'OTHER_1' : ['other', 'a:18', '-pred:NOT+pred'],
    'OTHER_2' : ['else', 'a:18', '-pred:pred'],

    'THAT' : ['that-$num$', 'det','-num:$num$', '-det:THAT'],

    
    
  
    # VERBS
    # actions
    'MOVE' :    ['move', 'v:2','-meta'],
    'DO'   :    ['do','v:1','-meta'],
    'HAPPEN' :    ['happen', 'v:2','-meta'],
    'TOUCH' :    ['touch', 'v:1','-meta'],

    # have, existence
    'HAVE' : ['have', 'v:1','-meta'],
    'EXIST' : ['there','d:4', '-det:$det$','-p:$p$', '-num:$num$', '-k:$k$'],

    # speech

    'SAY' :    ['say', 'v:1','-meta'],
    
    'WORD' :   ['word-$num$', 'n:1', '-num:$num$'],
    'TRUE' :    ['true', 'a:16'],

    # mental predicates
    'KNOW'   :   ['know','v:1','-meta'],
    'FEEL'   :   ['feel','v:1','-meta'],
    'THINK'   :  ['think','v:1','-meta'],
    'SEE'   :    ['see','v:1','-meta'],
    'HEAR'   :   ['hear','v:1','-meta'],
    'WANT'   :   ['want',
                  '=i:2', '+fin:nonf', '>',
                  'v:24', '-be:NOT+BE','-pol'],

    'PRO-P' : ['', 'i:2', '-fin:nonf'], 

    # life, death
    'LIVE' :    ['live', 'v:2','-meta'],
    'DIE' :    ['die', 'v:2','-meta'],


    # SPACE    
    'ABOVE' : ['above','loc:2'],
    'BELOW' : ['below','loc:2'],
    'INSIDE' : ['inside','loc:2'],

    'NEAR' : ['near','loc:2'], #?
    'FAR_1' : ['far', 'p_adv:3'],
    'FAR_2' : ['far', '=p:10', '>', 'p_adv:3'],

    'HERE' : ['here','p_adv:3'],

   'PLACE-X' : ['','p_adv:2'],

    # costruttori
    'F:LSPEC_1'  :  ['', '=loc:2', '=d:3', '+det','+p', '+num', '+k:acc', '>', 'p_adv:1'],
    'F:LSPEC_2'  :  ['', '=loc:X', '=p_adv:X', 'p_adv:X+1'],
    

    # TIME
 
    'BEFORE' : ['before','time:2'],
    'AFTER' : ['after','time:2'],

    'NOW' :  ['now','t_adv:3'],

    'TIME-X' : ['', 't_adv:2'],

     # time span (for duration or distance)
    'VERY_LONG_TIME' : ['a_very_long_time', 'time:3'],
    'LONG_TIME' : ['a_long_time', 'time:3'],
    'SOME_TIME' : ['some_time', 'time:3'],
    'SHORT_TIME' : ['a_short_time', 'time:3'],
    'MOMENT' : ['a_moment', 'time:3'],

    # costruttori
    'F:TSPEC_1'  :  ['', '=time:2', '=d:3', '+det', '+p', '+num', '+k:acc', '>', 't_adv:1'],
    'F:TSPEC_2'  :  ['', '=time:X', '=t_adv:X', 't_adv:X+1'],

    # NEGATOR
    'NOT' : ['not', '=v:X', 'v:X+1'],

    # INTENSIFICATOR
    'f:VERY' : ['very', '=a:X', '+pred:$pred$', '>', 'a:X', '-pred:$pred$'],

    # AUGMENTOR
    'MORE' : ['more', 'd:2', '-det',  '-p:3', '-num:$num$', '-k:$k$'],


    # INFL
    'f:PROG' : ['ING', '=v:X', '+meta', '>', 'a:22', '-pred:pred'],
    
    'f:PAST_1':  ['DID',
                   '=i:X', '+be:NOT+BE', '>',
                   '+det', '+p',  '+num', # '+k:nom',
                   'i:X+1', '-fin:fin'],
    
    'f:PAST_2':     ['was-$num$',
                   '=i:X','+be:BE', '>',
                   '+det', '+p', '+num:$num$', # '+k:nom',
                   'i:X+1', '-fin:fin'],

    'f:PRES_1':   ['DOES',
                   '=i:X', '+be:NOT+BE', '>',
                   '+det', '+p:3',  '+num:ONE', # '+k:nom',
                   'i:X+1', '-fin:fin'],

    'f:PRES_2':     ['DO',
                   '=i:X', '+be:NOT+BE', '>',
                   '+det', '+p',  '+num', # '+k:nom',
                   'i:X+1', '-fin:fin'],
    
    'f:PRES_3':     ['be-PRES-$num$',
                   '=i:X','+be:BE', '>',
                   '+det', '+p',  '+num:$num$', # '+k:nom',
                   'i:X+1', '-fin:fin'],
        
    'f:POT+PRES' : ['can',
                   '=i:X','+be', '>',
                   '+det', '+p',  '+num:$num$', # '+k:nom',
                   'i:X+1', '-fin:fin'],
    
    'f:FUT+PRES' :     ['will',
                   '=i:X','+be', '>',
                   '+det', '+p', '+num:$num$', # '+k:nom',
                   'i:X+1', '-fin:fin'],

    'f:POT+PAST' : ['could',
                   '=i:X','+be', '>',
                   '+det', '+p',  '+num:$num$', # '+k:nom',
                   'i:X+1', '-fin:fin'],
    
    'f:FUT+PAST' : ['would',
                   '=i:X','+be', '>',
                   '+det', '+p', '+num:$num$', # '+k:nom',
                   'i:X+1', '-fin:fin'],

    'INF' : ['to','=i:1','+be:$be$', '+pol', '>',
             '+det', '+p',  '+num:$num$',  '+k:acc',
             'i:2', '-fin:nonf'],
    #fused
    'f:PRO+SUBJ+INF' : [ 'to',
                         '=v:X', '+be:$be$', '+pol', '>',
                         'i:2', '-fin:nonf'],
    

    # COMPL
    'f:FIN_1' : ['', '=i:X','+pol','+fin:fin','+k:nom','c:3', '-wh:NOT+WH'],
    'f:FIN_2' : ['', '=i:X','+pol','+k:nom','+fin:fin','c:3', '-wh:WH'],

    'f:MAYBE' : ['maybe', '=c:3', '+wh:NOT+WH', '>', 'c:3', '-wh:NOT+WH'],

    'f:TOPIC' : ['', '=c:3','+wh:$WH$', '+top','c:3','-wh:$WH$'],
    
    'f:FACT' : ['that','=c:3','+wh:NOT+WH','>','c:5','-ctype:THAT'],
    'f:IF'   : ['if','=c:3','+wh:NOT+WH','>','c:5','-ctype:IF'],
    'f:BECAUSE'   : ['because','=c:3','+wh:NOT+WH','>','c:5','-ctype:BECAUSE'],
    'f:AS'   : ['as','=c:3','+wh:NOT+WH','>','c:5','-ctype:LIKE'],

    

    'f:DECL' : ['.','=c:3','+wh:NOT+WH','c:4'],
    'f:INT' : ['?','=c:3','+wh:WH','c:4'],
    
    'F:TOP_SUB_PRINC': [',',
                '=c:4',
                '=c:5', '+ctype',
                'c:5'],

    'F:SUB_PRINC': ['',             
                '=c:5', '+ctype',
                '=c:3', '+wh:$wh$',
                'c:3', '-wh:$wh$']

}






morph_lf = [

    #TENSE-MODE FUSION
    
    [' f:POT f:PRES ', ' f:POT+PRES '],
    [' f:FUT f:PRES ', ' f:FUT+PRES '],
    
    [' f:POT f:PAST ', ' f:POT+PAST '],
    [' f:FUT f:PAST ', ' f:FUT+PAST '],
    
    #EQUI-want
    [' f:VOL ', ' f:PRO+SUBJ+INF WANT '],

    [r' FACT P:(GOOD|BAD) EVAL ', r' FACT IT P:\1 PRED INFL FACT IF_THEN ',
     r' FACT P:\1 EVAL ', r' FACT IT P:(GOOD|BAD) PRED INFL FACT IF_THEN '
     ],

    #it is good if...
    [r' f:FACT P:(\w+) f:FIN f:DECL ',
     r' f:FIN P:\1 f:PRED IT F:SUBJ f:PRES f:FIN F:THEN_IF f:DECL ',
     r' f:FACT P:\1 f:FIN f:DECL ',
     r' f:FIN P:(\w+) f:PRED IT F:SUBJ f:PRES f:FIN F:THEN_IF f:DECL '],

    [' LIKE_THIS ', ' THIS_THING f:LIKE '],

    [' f:PROG ', ' f:PROG f:BE-P ']
    
    ]



morph_pf = [
  # compound forms
  ['the same', 'the_same' ],
  ['the other', 'the_other'],
  ['another', 'a other'],

  ['a very long time', 'a_very_long_time'],
  ['a long time', 'a_long_time'],
  ['some time', 'some_time'],
  ['a short time', 'a_short_time'],
  ['a moment', ' a_moment '],
  


  # BE: forms
  [' were ', ' was-SOME '],
  [' was ', ' was-ONE '],
  [' I am ', ' I be-PRES-ONE '],
  [' am I ', ' be-PRES-ONE I '],
  [' is ', ' be-PRES-ONE '],
  [' are ', ' be-PRES-SOME '],
  [' being ', ' ING [be] '],

  [r' (to|can|could|will|would) be ', r' \1 [be] ',
   r' \1 be ', r' (to|can|could|will|would) \[be\] '],

  # genitive
  
  ['s\' ', 's S '], 
  ['\'s ', ' S '], 

  [' my ', ' me S '],
  [' your ', ' you S '],
    
  # plural nouns
  [r' (person|thing|place|kind|part|body|word) ',r' \1-ONE ',
      r' \1 ',r' (person|thing|place|kind|part|body|word)-ONE '],  
  [' (person|thing|place|kind|part|word)s ',r' \1-SOME ',
      r' \1s ',r' (person|thing|place|kind|part|word)-SOME '], 
  [' bodies ', ' body-SOME '],


  # plural determiners
  [' these ', ' this-SOME '],
  [' this ', ' this-ONE '],
  [' those ', ' that-SOME '],
  [' that ', ' that | that-ONE '],
  
  # Case of pronouns
  [' I ', ' me-nom '],
  [' me ', ' me-acc '],

  [' he ', ' he-nom '],
  [' him ', ' he-acc '],
  [' she ', ' she-nom '],
  [' her ', ' she-acc '],



  [' do not ', ' DO not '],
  [' does not ', ' DOES not '],
  [' did not ', ' DID not '],


  # verbs: 0-FORM
    [r' (know|think|want|feel|hear|see|say|happen|live|move|have|do) ',
     r' \1 | DO+\1 ',
     r' \1 ',
     r' DO (know|think|want|feel|hear|see|say|happen|live|move|have|do) '],
  
   
  # verbs: D-form
  [r'(live|die|move|hear)d',   r'DID \1',
   r'\1d',   r'DID (live|die|move|hear)'],

  [r'(want|happen)ed',   r'DID \1',
   r'\1ed',   r'DID (want|happen)'],

  {'vars'    : {'$Vi$' : '(<thought::think>|<knew::know>|<felt::feel>|<saw::see>|<said::say>|<had::have>)'},
   'table' : True,            
   'surf' : r' $Vi$ ',
   'deep' : r' DID $Vi$ '},

  # verbs: S-form
  [' touches ', ' DOES touch '],
  [' has ', ' DOES have '],
  
  [r'(know|think|want|feel|hear|see|say|live|die|move|happen)s',   r'DOES \1',
   r'\1s',   r'DOES (know|think|want|feel|hear|see|say|live|die|move|happen)'],

  # verbs : ING-form
  [r'(know|think|want|feel|hear|see|say|happen|do)ing',   r'ING \1',
   r'\1ing',   r'ING (know|think|want|feel|hear|see|say|happen|do)'],
  [r'(liv|mov|hav)ing',   r'ING \1e',
   r'\1ing',   r'ING (liv|mov|hav)e'],

  # verbs : DO
  [' does ',  ' DOES | DOES+do '],
  [' did ', ' DID | DID+do ']
]




text = {}

