import  interface, morph, variables
#,minimal

def add_continuation(item,i,s,stack,continuations):
    continuations.append(tuple([item,i,s,stack]))


def not_saturated(tree):
    for item in tree[3:]:
        if (type(item) == str and item != ''
            and item[0] == '+' or item[0] == '-' or item[0] == '='):
            return True
    else:
        return False
        
    
def lookup(pred,lex,i,gtype):
    if lex.has_key(pred):
        item = morph.lookup_gen(pred,lex,gtype)
        return item,0
    else:
        i += 1
        pred += '_' + str(i)
        if lex.has_key(pred):
            item = morph.lookup_gen(pred,lex,gtype)
            return item,i
        else: return None,0
    
        

def gen(s,lex,minimal,gtype):
    interface.var_number = 0
    interface.op_counter = 0
    continuations, stack = [] , []
    save_stack = None
    item,i = lookup(s[0],lex,0,gtype)
    if interface.verbose: interface.notify('SCAN',item,stack)
    stack.append(item)
    if i > 0:
        add_continuation(s[0],i,s[:],stack[:],continuations)
#       if interface.verbose:
#                interface.notify_continuation(pred,i,s,stack)
    s = s[1:]
    i = 0
    while s <> []:
        pred = s.pop(0)
        item,i = lookup(pred,lex,i,gtype)
        if interface.verbose: interface.notify('SCAN',item,stack)
        if not item:
            while continuations <> []:
                pred,i,s,stack = continuations.pop()
                item,i = lookup(pred,lex,i,gtype)
                if interface.verbose: interface.notify('SCAN',item,stack)
            if not item:
                if interface.verbose:
                    interface.notify_message('FAIL')
                return save_stack
            else:
                if interface.verbose:
                    interface.notify_backtrack(pred,i,s,stack)
        if i > 0:
            add_continuation(pred,i,s[:],stack[:],continuations)
            if interface.verbose:
                interface.notify_continuation(pred,i,s,stack)
        newitem = minimal.trymerge(item[:],stack[-1][:])
        if newitem and interface.verbose:
            interface.notify('MERGE', newitem, stack)
        while newitem:
            stack.pop()            
            newitem2 = minimal.trymove(newitem[:])            
            while newitem2:
                if interface.verbose:
                    interface.notify('MOVE', newitem2, stack)        
                newitem, newitem2 = newitem2, minimal.trymove(newitem2[:])
            if newitem2:
                newitem = newitem2
            if stack <> []:
                item, newitem = newitem, minimal.trymerge(newitem[:],stack[-1][:])
                if newitem and interface.verbose:
                    interface.notify('MERGE', newitem, stack)        
            else:
                item, newitem = newitem, None
        f = minimal.get_top_feature(item)
        if f.startswith('+') or f.startswith('-') or f.startswith('='):
            if continuations <> []:
                if interface.verbose:
                    interface.notify('DROP',item,[])
                pred,i,s,stack = continuations.pop()
                if interface.verbose:
                    interface.notify_backtrack(pred,i,s,stack)
                s.insert(0,pred)
            else:
                if interface.verbose:
                    interface.notify('FAIL','',[])
                return save_stack
        else:
            stack.append(item)
            i = 0
        if s == []:
            f = minimal.get_top_feature(stack[0])
            if ( (not(f.startswith('+') or f.startswith('-') or f.startswith('='))) 
                and interface.test_mode): 
                return [stack[-1]]
            if (len(stack) > 1 or not_saturated(stack[0])):
	        save_stack = stack[:]
                if continuations <> []:
                    if interface.verbose:
                        interface.notify('DROP',item,[])
                    pred,i,s,stack = continuations.pop()
                    if interface.verbose:
                        interface.notify_backtrack(pred,i,s,stack)
                    s.insert(0,pred)
                else:
                    return stack
    return stack


def lf2pf(lf,lang):
    lf1 = morph.customize(lf, lang.custom_lf,True,False)
    lf1 = lf1.split(' ')
    pf_list = gen(lf1,lang.lex,lang.g,lang.gtype)
    if pf_list and type(pf_list) == list:
        pf2 = pf_list[0][0][2]
        pf1 = variables.inst_default(pf2,lang.default)
        pf = morph.customize(pf1, lang.custom_pf,False,True)    
        return pf
    else:
        return '??'



