from grammars import *
import errors, re, minimal, mirror


l1 = None
l2 = None

l1_code = 'xxx'
l2_code = 'xxx'
       




    

class MinGrammar:
    def __init__(self,code):
        if code == 'xxx':
            self = None
        else:
            self.code = code
            try:
                finds = 'lex'
                self.lex = eval(code +  '.lexicon')
                self.gloss, self.e_list = make_inv_dict(self.lex)
                finds = 'default'
                self.default = eval(code +  '.default')
                finds = 'features'
                self.features = eval(code +  '.features')
                finds = 'morph_pf'
                self.custom_pf_src = eval(code + '.morph_pf')
                finds = 'morph_lf'
                self.custom_lf_src = eval(code + '.morph_lf')
                self.custom_lf = compile_custom(self.custom_lf_src,True)
                self.custom_pf = compile_custom(self.custom_pf_src,False)

                try: self.gtype = eval(code+'type')
                except NameError : self.gtype = 'S'

                try: self.text = eval(code+'text')
                except NameError : self.text = dict()

                try: self.title = eval(code+'title')
                except NameError : self.title = ' ** ' + code + ' GRAMMAR ** '

                try: self.text = eval(code+'txt_lf')
                except NameError : self.custom_lf_txt = []


                if self.gtype == 'S':
                    self.g = minimal
                elif self.gtype == 'B':
                    self.g = mirror
                    
                
   
            except NameError:
                self = None
                raise errors.ClineError('Grammar for language code "'
                                        + code + '" not found ')
            except AttributeError:
                self = None
                raise errors.ClineError('Grammar for language code "'
                                        + code + '" not complete.\n' +
                                        "Can't find variable: " +
                  code+'.'+finds+'"')




    

def make_inv_dict(d):
    i_d = dict()
    e_l = list()
    for key, val in d.iteritems():
        entry = val[0]
        if  i_d.has_key(entry):
            i_d[entry].append(key)
        else:
            i_d[entry] = [key]
        if (entry == '') or (entry[0] == '[' and entry[-1] == ']'):
            e_l.append(key)
    return i_d, e_l


def find_subs(s,_open,_close):
    _from = s.find(_open)
    _to = s.find(_close)
    if (_from <> -1) and (_to <> -1) and (_from < _to):
        return s[_from+1:_to]
    else:
        return ''



def twotape_get_one(s,d1,d2):
    s1, s2 = s[:], s[:]
    couple = find_subs(s1,'<','>')
    if couple == '': couple = find_subs(s2,'<','>')
    while couple <> '':
        v = couple.split ('::')
        if len(v) == 1:
            v.append(v[0])
        d1[v[0]] = v[1]
        d2[v[1]] = v[0]
        s1 = s1.replace('<'+couple+'>',v[0])
        s2 = s2.replace('<'+couple+'>',v[1])
        couple = find_subs(s1,'<','>')
        if couple == '': couple = find_subs(s2,'<','>')
    return s1, s2
    
    

def compile_custom(rules,is_lf):
    new_rules = []
    for r in rules:
        if type(r) == dict:
            rule = list()
            rule.append(r['surf'][:])
            rule.append(r['deep'][:])
            rule.append(r['surf'][:])
            rule.append(r['deep'][:])
            
            if r.has_key('table'):
                var_symb = '%'
                d1, d2 = dict(), dict()
            else:
                var_symb = '$'
                
            for n,v in enumerate(r['vars']):
                if r.has_key('table'):
                    v0, v4 = twotape_get_one(r['vars'][v],d1,d2)
                else:
                    v0, v4 = r['vars'][v], r['vars'][v]
                rule[0] = rule[0].replace(v,v0) #rule0
                rule[1] = rule[1].replace(v,var_symb+str(n+1))
                rule[2] = rule[2].replace(v,var_symb+str(n+1)) #rule2
                rule[3] = rule[3].replace(v,v4) #rule3
            if r.has_key('table'):
                rule.append(d1)
                rule.append(d2)
                rule.append(True)
            
        else:
            rule = r
        if len(rule) == 4:
            new_rules.append([re.compile(rule[0]),
                              backref(rule[1]),
                              backref(rule[2]),
                              re.compile(rule[3])])
        elif len(rule) == 7:
            new_rules.append([re.compile(rule[0]),
                              backref(rule[1]), backref(rule[2]),
                              re.compile(rule[3]),
                              rule[4], rule[5],True])
        else:
            new_rules.append(rule)
    return new_rules
                                  

def backref(s):
    return s[:].replace('$','\\')


def set_grammar(l1_or_l2,code):
    global l1, l2, l1_code, l2_code
    if (l1_or_l2 == 1):
        if code == 'xxx': l1 = None
        else: l1 = MinGrammar(code)
        l1_code = code
    else:
        if code == 'xxx': l2 = None        
        else: l2 = MinGrammar(code)
        l2_code = code

  
    
