# -*- coding: cp1252 -*-
import variables

dist_cat = 'c'


def contiguous(from1,to1,from2,to2,invert=False):
    if (from1,to1) == (-1,-1) and (from2,to2) != (-1,-1):
        return True
    elif (from1,to1) != (-1,-1) and (from2,to2) == (-1,-1):
        return True
    else:
        if invert:
            from1, to1, from2, to2 = from2, to2, from1, to1
        return (to1 == from2 and to1 != -1 and from1 < to2)


def add_span(from1,to1,from2,to2,invert=False):
    if invert:
        from1, to1, from2, to2 = from2, to2, from1, to1
    if (from1,to1) == (-1,-1):
        return from2,to2
    elif (from2,to2) == (-1,-1):
        return from1,to1
    else:
        return from1,to2

    
def get_top_feature(item):
    if len(item) <= 2: return None 
    else: return item[2]


    

def merge3(i1,i2,cat):
    old_i1, old_i2 = i1[:], i2[:]
    i1[1] = ':'
    i2[1] = ':'
    i = variables.pos('#',i1,0)
    if i <> -1:
        i1_rest_chain = i1[i:]
        i1 = i1[:i]
    else: i1_rest_chain = []
    i = variables.pos('#',i1,0)
    if i <> -1:
        i2_rest_chain = i2[i:]
        i2 = i2[:i]
    else: i2_rest_chain = []
    i1[0] = (i1[0][0], i1[0][1], i1[0][2], i2[0][3]+' ' +i1[0][3])
    i1.append('#')
    i1.extend(i2)
    i1.extend(i1_rest_chain)
    i1.extend(i2_rest_chain)
    return i1



def merge2(i1,i2,cat,invert):
    old_i1 = i1[:]
    from3,to3 = add_span(i2[0][0],i2[0][1],i1[0][0],i1[0][1],invert)
    if invert: s = i1[0][2] + ' ' + i2[0][2]
    else: s = i2[0][2] + ' ' + i1[0][2]
    i1[0] = tuple([from3,to3,
                   s,
                   i2[0][3] + ' ' + i1[0][3]])
    variables.add_list(i1,i2[1:])
    i1[1] = ':'
    return i1



def merge1(i1,i2,cat,invert):
    old_i1 = i1[:]
#    i1[1] = ':'
    from3,to3 = add_span(i1[0][0],i1[0][1],i2[0][0],i2[0][01],invert)
    if invert: s = i2[0][2] + ' ' + i1[0][2]
    else: s = i1[0][2] + ' ' + i2[0][2]
    i1[0] = tuple([from3,to3,
                   s,
                   i2[0][3] + ' ' + i1[0][3]])
    variables.add_list(i1,i2[1:])
    return i1



def can_merge(i1,i2,top_lf):
##    if i1[-1] == '=':
##        i1 = '=' + i1[:-1]
    if i1[0] != '=':
        return False
    elif i1[1:] == i2:
        return True
    elif '|' in i1[0]:
        for alt in i1[0].split('|'):
            new_i1 = [alt.strip()]
            new_i1.extend(i1[1:])
            if can_merge(new_i1,i2,top_lf):
                return True
        else: #else del for
            return False
    elif ':' in i1 or ':' in i2:
        f1, f2 = i1[1:].split(':'), i2.split(':')
        if len(f1) == 2 and len(f2) == 2:
            if f1[1] == 'X' or f2[1] == 'X':
                if '/' in f1[0]:
                   i1_ar = f1[0].split('/')
                   n, h = i1_ar[0], i1_ar[1]
                   return n == f2[0] and top_lf.startswith(h)
                else: return f1[0] == f2[0]
            else:
                try: n1, n2 = int(f1[1]), int(f2[1])
                except ValueError: return False
                if '/' in f1[0]:
                   i1_ar = f1[0].split('/')
                   n, h = i1_ar[0], i1_ar[1]
                   return n == f2[0] and top_lf.startswith(h) and n1 >= n2
                else: return f1[0] == f2[0] and n1 >= n2
        else: 
            if '/' in f1[0]:
                i1_ar = f1[0].split('/')
                n, h = i1_ar[0], i1_ar[1]
                return n == f2[0] and top_lf.startswith(h)
            else:
                return f1[0] == f2[0]
    elif '/' in i1:
        i1_ar = i1.split('/')
        n, h = i1_ar[0], i1_ar[1]
        return n == i2 and top_lf.startswith(h)
##        else:
##            return False # f1[0] == f2[0]
# originale che va:    return i1[0] == '=' and i1[1:] == i2


def update_level(item,cat):
    f = cat.split(':')
    if len(f) == 2:
        try: n = int(f[1])
        except ValueError: return
        else:
            l, l1 = str(n), str(n+1)
            for i in range(0,len(item)):
                if type(item[i]) == str:
                    if item[i].endswith(':X'):
                        item[i] = item[i][:-1] + l
                    elif item[i].endswith(':X+1'):
                        item[i] = item[i][:-3] + l1

                        
def trymerge(item,top):
    if len(item) > 2 and len(top) > 2 and can_merge(item[2],top[2],top[0][3]):
        cat = top.pop(2)
        selector = item.pop(2)
##        if selector[-1] == '=' and len(item) > 1 and item[1] == '::':
##            invert = True
##        elif len(item) > 2 and item[2] == '>':
##            invert = True
##            item.pop(2)
        if len(item) > 2 and item[2] == '>':
            invert = True
            item.pop(2)
        else:
            invert = False
        if selector.endswith(':X'):
            update_level(item,cat)
        if ( (not '#' in item)
             and len(item) > 1 and item[1] == '::'
             and variables.is_last_feature(top)):
            return merge2(item,top,cat,invert)
        elif item[1] == ':' and variables.is_last_feature(top):
            return merge1(item,top,cat,invert)
        else:
            return merge3(item,top,cat)
    else:
        return False


    


def try_unmerge(item,top):
    if len(item) > 2 and len(top) > 2 and can_merge(item[2],top[2],top[0][3]):
        selector = item.pop(2)
        cat = top.pop(2)
        if len(item) > 2 and item[2] == '>':
            invert = True
            item.pop(2)
        else:
            invert = False
        if selector.endswith(':X'):
            update_level(item,cat)
        from1,to1 = item[0][0],item[0][1]
        from2,to2 = top[0][0],top[0][1]

        if variables.is_last_feature(top):
            if contiguous(from2,to2,from1,to1,invert):
                return merge2(item,top,cat,invert)
            elif contiguous(from1,to1,from2,to2,invert):
                return merge1(item,top,cat,invert)
            elif from1 == -1 and from2 == -1:
                if variables.pos('#',top,0) <> -1:
                    return merge1(item,top,cat,invert)
                elif variables.pos('#',item,0) <> -1:
                    return merge2(item,top,cat,invert)
                else:
                    return False
            else:
                return False
        else:
            if from1 == -1 or from2 == -1 and (
                variables.pos('#',item,0) <> -1 or
                variables.pos('#',top,0) <> -1):
                return merge3(item,top,cat)
            if to1 == to2 and from1 < from2:
                return False
            elif from1 == from2 and to2 > to1:
                return False
            elif from1 >= from2 and to1 <= to2:
                return False
            if (to1 <= from2) or (from2 == -1):
                return merge3(item,top,cat)
            elif (to2 <= from1) or (from1 == -1):
                return merge3(item,top,cat)
            else:return False
            

##        if ( (not '#' in item)
##             #and len(item) > 1 and item[1] == '::'
##             and variables.is_last_feature(top)
##             and contiguous(from2,to2,from1,to1,invert) ):
##            return merge2(item,top,cat,invert)
##        elif  ( not '#' in item  # item[1] == ':'
##                and
##                 variables.is_last_feature(top)
##                 and contiguous(from1,to1,from2,to2,invert) ):
##            return merge1(item,top,cat,invert)
##        else: 
##            if to1 == to2 and from1 < from2:
##                return False
##            elif from1 == from2 and to2 > to1:
##                return False
##            if (to1 <= from2) or (from2 == -1):
##                return merge3(item,top,cat)
##            elif (to2 <= from1) or (from1 == -1):
##                return merge3(item,top,cat)
##            else:return False
    else:
        return False

##def try_unmerge(i1,i2):
##    if can_merge(i1[2],i2[2]):
##        i1.pop(2)
##        cat = i2.pop(2)
##        if ( (not '#' in i1)
##             and len(i1) > 1 and i1[1] == '::'
##             and variables.is_last_feature(i2)
##             and contiguous(i1[0][0],i1[0][1],i2[0][0],i2[0][1]) ):
##            return merge1(i1,i2,cat)
##        elif ( i1[1] == ':'
##               and variables.is_last_feature(i2)
##               and contiguous(i2[0][0],i2[0][1],i1[0][0],i1[0][1]) ):
##            return merge2(i1,i2,cat)
##        else:
##            return merge3(i1,i2,cat)
##    else:
##        return False



def move2(ch1,ch2,item):
    ch1.append('#')
    ch1.extend(ch2)
    return ch1


def move1(ch1,ch2,item,covert):
    old_item = item[:]
    if covert:
        from3,to3 = add_span(ch1[0][0],ch1[0][1],ch2[0][0],ch2[0][1],False)    
        ch1[0] = tuple([from3,to3,
                        ch1[0][2]+' '+ ch2[0][2],
                        ch1[0][3]])
    else:
        from3,to3 = add_span(ch2[0][0],ch2[0][1],ch1[0][0],ch1[0][1],False)
        ch1[0] = tuple([from3,to3,
                        ch2[0][2]+' '+ ch1[0][2],
                        ch1[0][3]])
    if '#' in ch2:
        ch1.extend(ch2[ch2.index('#'):])
    variables.add_list(ch1,ch2)


##def can_move(f1,f2):
##    if f1[0][0] <> '+' or f2[0][0] <> '-':
##        return False
##    elif f1[0][1:] <> f2[0][1:]:
##        return False
##    elif len(f1) < 2 or len(f2) < 2:
##        return True
##    elif f1[1][0] == '$' or f2[1][0] == '$':
##        return True
##    else:
##        return f1[1] == f2[1]
    
    
#    return f1[0][1:] == f2[0][1:] and f1[0][0] == '+' and f2[0][0] == '-'

##def trymove(item):
##    i = pos('#',item)
##    while i <> -1:
##        ch1, ch2 = item[:i],item[i+1:]
##        if len(ch1) > 2 and len (ch2) > 2:
##            f1 = ch1[2].split(':')
##            f2 = ch2[2].split(':')
##            if can_move(f1,f2):
###            if f1[0][1:] == f2[0][1:] and f1[0][0] == '+' and f2[0][0] == '-':
##                ch1.pop(2)
##                ch2.pop(2)
##                covert = ch1[2] == '>'
##                if covert: ch1.pop(2)
##                ch1, ch2 = inst_variables(ch1,ch2,f1,f2)
##                if ch1 and ch2:
##                    if is_last_feature(ch2):
##                        move1(ch1,ch2,item,covert)
##                        return ch1
##                    else:
##                        move2(ch1,ch2,item)
##                        return ch1
##                else:
##                    i = pos('#',item,i+1)
##            else:
##                i = pos('#',item,i+1)
##        else:
##            i = pos('#',item,i+1)               
##    else:
##        return False


def inst_feature_dict(item):
    if len(item) > 0 and type(item) == list and type(item[-1]) == dict:
        d = item.pop()
        for key in d:
            for j in range(2,len(item)):
                item[j] = item[j].replace(key,d[key])
            


def prepare_move(item,i):
    ch1, ch2 = item[:i],item[i+1:]
    fv1, fv2 = get_top_feature(ch1), get_top_feature(ch2)
    if fv1 and fv2:
        f1, f2 = fv1.split(':'), fv2.split(':')
        if f1[0][1:] == f2[0][1:] and f1[0][0] == '+' and f2[0][0] == '-':
            ch1.pop(2)
            ch2.pop(2)
            covert = len(ch1) > 2 and ch1[2] == '>'
            if covert: ch1.pop(2)
            inst_feature_dict(ch1)
            inst_feature_dict(ch2)
            ch1, ch2 = variables.inst_variables(ch1,ch2,f1,f2)
            return ch1, ch2, covert
        else:
            return None


def trymove(item,unmove = False):
    i = variables.pos('#',item)
    while i <> -1:
        chains = prepare_move(item,i)
        if chains and chains <> (None,None,False):
            ch1, ch2, covert = chains
            if ch1 and ch2:
                if variables.is_last_feature(ch2):
                    if not unmove:
                        move1(ch1,ch2,item,covert)
                        return ch1
                    else:
                        if ((not covert) and contiguous(ch2[0][0],
                                                        ch2[0][1],
                                                        ch1[0][0],
                                                        ch1[0][1],
                                                        False)
                            or (covert and contiguous(ch1[0][0],
                                                        ch1[0][1],
                                                        ch2[0][0],
                                                        ch2[0][1],
                                                      False))
                            ):
                            move1(ch1,ch2,item,covert)
                            return ch1
                        else:
                            i = variables.pos('#',item,i+1)
                else:
                    move2(ch1,ch2,item)
                    return ch1
            else: i = variables.pos('#',item,i+1)
        else:
            i = variables.pos('#',item,i+1)               
    return None

    




