import variables, interface, re, twotape, errors #, min_grammar #, tree


cucca0 = re.compile(r'(\(\))')
cucca1 = re.compile(r'(\(\+[^\)]*\))')
cucca2 = re.compile(r'(\([^\)\+]*\+\))')
cucca3 = re.compile(r'(?:\ \ |\-\-)+')
cucca4 = re.compile(r'\B\_\d+\b')


def strip_index(s):
    return cucca4.sub('',s)

def strip_aff(w,G):
    var_number = 0
    d = dict()
    s = ''
    morphemes = w.split('-')
    for m in morphemes:
        if G.features.has_key(m):
            if d.has_key(G.features[m]):
                var_number += 1
                d[G.features[m]+ str(var_number)] = m
                s += '-$' + G.features[m] + str(var_number) + '$'
            else:
                d[G.features[m]] = m
                s += '-$' + G.features[m]  + '$'
        else:
            s += '-' + m
    return s[1:],d




def lookup_gen(w,lex,gtype):
    if not lex.has_key(w):
            return None
    item = lex[w][:]
    if type(item[-1] ) == dict:
        d = item.pop()
        for key in d:
            for j in range(0,len(item)):
                item[j] = item[j].replace(key,d[key])
    if w.startswith('f:'): item.insert(1,':')
    else: item.insert(1,'::')    
    item = variables.index_vars(item)
    if gtype == 'S':
        head = tuple([0,0,item.pop(0),w])
    elif gtype == 'B':
        head = tuple([0,0,','+item.pop(0)+',',w])
    item.insert(0,head)
    return item



def lookup_parse(w,G,i):
    stem, values = strip_aff(w,G)
    if not G.gloss.has_key(stem):
       interface.alert('Item "' + stem + '" not in reverse lexicon')
       raise errors.ClineError('Not Found')
    lf_list = G.gloss[stem]
    new_entry_list = []
    for lf in lf_list:
        if not G.lex.has_key(lf):
            interface.alert('Item "' + lf + '" not in lexicon')
            raise errors.ClineError('Not Found')
        entry = G.lex[lf][:]
        new_entry = []
        if type(entry[-1]) == dict:
            d = entry.pop()
            for key in d:
                for j in range(0,len(entry)):
                    entry[j] = entry[j].replace('$'+key+'$',d[key]) 
#            entry = entry[:-1]
        for item in entry:
            for f in values:
                item = item.replace('$'+f+'$',values[f])
##            for f in G.default:
##                item = item.replace('$'+f+'$',G.default[f])
            new_entry.append(item)
        if w.startswith('f:'): new_entry.insert(1,':')
        else: new_entry.insert(1,'::')
        if G.gtype == 'S':
            head = tuple([i,i+1,new_entry[0],lf])
        elif G.type == 'B':
            head = tuple([tuple([-1,i,-1]),tuple([-1,i+1,-1]),','+new_entry[0]+',',lf])            
        new_entry[0] = head
        new_entry_list.append(new_entry)
    return new_entry_list




def sub_1tape(s,src,repl):
   s = src.sub(repl,s)
   s = cucca1.sub('',s)
#   s = cucca2.sub('',s)
#   s = s.replace('(','').replace(')','').replace('+',' ')
   s = cucca3.sub(' ',s)
   return s



def sub_2tape(s,src,repl,table):
   s = twotape.twotape_sub(src,s,repl,table)
   s = cucca1.sub('',s)
#   s = cucca2.sub('',s)
#   s = s.replace('(','').replace(')','').replace('+',' ')
   s = cucca3.sub(' ',s)
   return s




def customize(s, rl, direct = True, pf = True):
  replace_list = rl[:]
  if direct:
    i_src, i_res, regex_add, twotape_add = 0, 1, 0, 4
  else:
    i_src, i_res, regex_add, twotape_add = 1, 0, 2, 5
  if interface.verbose:
      if pf: pf_or_lf = 'PF'
      else: pf_or_lf = 'LF'
      interface.notify_message(' ========= '+pf_or_lf + ' REWRITE RULES =========')
  if not direct:
        replace_list.reverse()        
  s = ' ' + s + ' '
  for item in replace_list:
     if (len(item) == 7):
        s1 = sub_2tape(s,
                      item[i_src+regex_add],
                      item[i_res+regex_add],
                      item[twotape_add])
     elif (len(item) == 4):        
        s1 = sub_1tape(s,item[i_src+regex_add],item[i_res+regex_add])
##     elif type(item[0]) == list:
##        s = tree.replace_tree(s,item[i_src])
     else:
        s1 = s.replace(item[i_src], item[i_res])
     s1 = cucca3.sub(' ',s1)
     if interface.verbose and s1<>s:
         interface.notify_change(s1)
     s = s1
  return s.strip()


def scan(lf,rules,direct):
    return customize(lf,rules,direct).split(' ')
