import morph, interface, variables, re , errors, ug, minimal



cucca5 = re.compile(r' +')


def append_alternatives(item,agenda,g,ind):
    array, length = [],1
    for alt in item.split('|'):
        array.append(alt.split('+'))
        if len(array[-1]) > length:
            length = len(array[-1])
    new_i = ind + length
    for alt in array:
        i = ind
        for morpheme in alt:
            entry_list = morph.lookup_parse(morpheme,g,i)
            i += 1
            for entry in entry_list:
                if alt.index(morpheme) == len(alt)-1:
                    entry[0] = tuple([entry[0][0],new_i,entry[0][2],entry[0][3]])
                agenda.append(entry)
                
    return new_i
        
    
        


def init_agenda(lex_items,g):
    agenda = []
    i = 0
    for item in lex_items:
        if '|' in item:
            i = append_alternatives(item,agenda,g,i)
        else:
            entry_list = morph.lookup_parse(item,g,i)
            i += 1
            for entry in entry_list:
                agenda.append(entry)
      
    for entry in g.e_list:
        new_entry = g.lex[entry][:]
        new_entry.insert(1,'::')
        new_entry[0] = tuple([-1,-1,'',entry])
        agenda.append(new_entry)
    if interface.verbose:
        interface.notify_init(agenda)
    return i, agenda




def double_merge(item):
    i = variables.pos('#',item,0)
    positions = [item[0]]
    while i <> -1:
        positions.append(item[i+1])
        i = variables.pos('#',item,i+1)
    if len(positions) > 1:
        while positions:
            p = positions.pop(0)
            if p[0] <> -1:
                for p1 in positions:
                    if p1[0] <> -1:
                        if ( (p[0] >= p1[0] and p[1] <= p1[1]) or
                             (p1[0] >= p[0] and p1[1] <= p[1]) ):
                            return True
        
def check_restrictions(pred,lf):
    if not ug.restrictions.has_key(lf):
        return True
    else:
        return ug.restrictions[lf].find('# '+ lf + ' ' + pred  + ' #') <> -1


def try_inference(minimal,item,pivot,s):
    newitem = (minimal.try_unmerge(item[:],pivot[:]) or
               minimal.try_unmerge(pivot[:],item[:]) )
    if newitem:
          if double_merge(newitem) or not check_restrictions(pivot[0][3],item[0][3]):
              return None
          newitem2 = minimal.trymove(newitem,True)
          while newitem2:
              newitem, newitem2 = newitem2, minimal.trymove(newitem,True)
              if newitem2: newitem = newitem2
          f = minimal.get_top_feature(newitem)
          if ( type(f) == str and
               ( f.startswith('+') or f.startswith('-')) ):
              return None
          else:
              return newitem
    else:
       return None


def add_to_structure(newitem,struc):
    for item in struc:
        if newitem == item:
            return False
    struc.append(newitem)
    return True


def chart_parse(agenda,s,minimal):
    item = agenda.pop(0)
##    if interface.verbose:
##        interface.notify('ADD',item,[])
    chart = [item]
    while agenda:
        pivot = agenda.pop(0)
        for item in chart:
            newitem = try_inference(minimal,item,pivot,s)
            if newitem: add_to_structure(newitem,agenda)
        added_to_chart = add_to_structure(pivot,chart)
        if interface.verbose and added_to_chart:
            interface.notify('ADD',pivot,[])
    return chart



def extract_parse(i,chart):
    chart.reverse()
    for item in chart:
        From, To, pf, parse = item[0]
        if From == 0 and To == i:
            if (len(item) > 1 and 
               (item[2] == minimal.dist_cat or item[2].startswith(minimal.dist_cat + ':'))):
                return parse
            

def pf2lf(s,lang):
    if (not interface.test_mode) and (
        not(s.endswith('.') or s.endswith('?') or s.endswith('!'))):
        s += ' .'
    s1 = morph.customize(s, lang.custom_pf,True,True)
    s1 = s1.replace(' | ','|').replace(' + ','+')
    wlist = s1.split(' ')
    try: i,agenda = init_agenda(wlist,lang)
    except errors.ClineError: return '??'
    else:
        chart = chart_parse(agenda,s1,lang.g)
        parse = extract_parse(i,chart)
        if parse and type(parse) == str:
            lf1 = morph.strip_index(parse)
            lf = morph.customize(lf1,lang.custom_lf,False,False)
            return lf
        else:
            return '??'
    
    
    
