format = 'POSTFIX'

def build_tree(s):
  if s == '??':
      return []
  tree = []
  for item in s.split(' '):
    if item.startswith('f:'):
       if len(tree) > 0:
          tree.append([item,tree.pop()])
    elif item.startswith('F:'):
       if len(tree) > 1:
          tree.append([item,tree.pop(),tree.pop()])
    else:
       tree.append(item)
  if len(tree) > 0: return tree[0]
  else: return [] 


def linearize(t):
    if type(t) == str:
       return t
    elif len(t) == 1:
       return linearize(t[1]) + ' ' + t[0]
    else:
       return linearize(t[2]) + ' ' + linearize(t[1]) + ' ' + t[0]
        
        
        

def export_tree_lisp(tree):
  if type(tree) == str:
     return tree
  elif type(tree) == list:
     if len(tree) == 2:
        return '(' + tree[0] + ' ' + export_tree_lisp(tree[1]) + ')'
     elif len(tree) == 3:
        return '(' + tree[0] + ' ' + export_tree_lisp(tree[1]) + ' ' +  export_tree_lisp(tree[2]) + ')'

     

def export_tree_prolog(tree):
  if type(tree) == str:
     return tree
  elif type(tree) == list:
     if len(tree) == 2:
        return tree[0] + '(' + export_tree_prolog(tree[1]) + ')'
     elif len(tree) == 3:
        return tree[0] + '(' + export_tree_prolog(tree[1]) + ', ' +  export_tree_prolog(tree[2]) + ')'


def export_tree_latex(tree):
  return '\\begin{parsetree}' + export_tree_parsetree(tree) + '\n\\end{parsetree}\n'


def export_tree_parsetree(tree,indent = 0):
  if type(tree) == str:
     return '.' + tree + '.'
  elif type(tree) == list:
     if len(tree) == 2:
        return '\n'+' '*indent + '(.' + tree[0] + '. ' + export_tree_parsetree(tree[1],indent+2) + ')'
     elif len(tree) == 3:
        return '\n'+' '*indent + '(.' + tree[0] + '. ' + export_tree_parsetree(tree[1],indent+2) + ' ' +  export_tree_parsetree(tree[2],indent+2) + ')'
   

def find_spec(t,head):
  p = t
  while type(p) == list:
     if p[0] == head:
         return p[1]
     else:        
         p = p[-1]
  return None


def find_node(t,head):
  p = t
  while type(p) == list:
     if p[0] == head:
         return p
     else:        
         p = p[-1]
  return None


 
def find_subj(t):
  return find_spec(t,'F:SUBJ')



def match_node(tree,node):
    if node.find(',') == -1:
        return find_node(tree,node)
    else:
        h_spec = node.split(',')
        h, spec = h_spec[0], h_spec[1] 
        n = find_node(tree,h)
        if not n: return None
        if spec.startswith('/'):
            if find_node(n[1], spec[1:]):
                return n
            else:
                return None
        else:
            if n[1] == spec:
                return n
            else:
                return None   


def change_node(node,newnode):
    if newnode == '=':  return
    elif newnode.find(',') == -1:
       node[0] = newnode
    else:
       h_spec = newnode.split(',')
       if h_spec[0] <> '=': node[0] = h_spec[0]
       node[1] = h_spec[1]
           
         
